% this script reads the training and test digits and labels
% of the MNIST database, and it scrambles them using a random
% permutation, so that any random range of the test or training
% set is equivalent to any other random range.

disp('loading test data...');
clear;
test_digits = read_test_digits;
test_labels = read_test_labels;
number = size(test_digits, 3);

disp('transposing test data...');
for i = 1:number
   test_digits(:, :, i) = [test_digits(:, :, i)]';
end

disp('scrambling test data...');
test_permutation = randperm(number);
test_digits = test_digits(:, :, test_permutation);
test_labels = test_labels(test_permutation);

disp('saving test data...');
filename = '..\\mnist\\scrambled_test.bin';
fid = fopen(filename, 'w');
fwrite(fid, number, 'int32');
fwrite(fid, test_permutation, 'int32');
fwrite(fid, test_labels, 'uchar');
fwrite(fid, test_digits, 'uchar');
fclose(fid);

disp('loading training data...');
clear;
training_digits = read_training_digits;
training_labels = read_training_labels;
number = size(training_digits, 3);

disp('transposing training data...');
for i = 1:number
   training_digits(:, :, i) = [training_digits(:, :, i)]';
end

disp('scrambling training data...');
training_permutation = randperm(number);
training_digits2 = training_digits(:, :, training_permutation(1:number/2));
training_labels = training_labels(training_permutation);

disp('saving training data...');
filename = '..\\mnist\\scrambled_training.bin';
fid = fopen(filename, 'w');
fwrite(fid, number, 'int32');
fwrite(fid, training_permutation, 'int32');
fwrite(fid, training_labels, 'uchar');
fwrite(fid, training_digits2, 'uchar');
clear training_digits2;
training_digits2 = training_digits(:, :, training_permutation((number/2+1):number));
fwrite(fid, training_digits2, 'uchar');
fclose(fid);
