function result = vcompare(matrix1, matrix2)

% compares two matrices, so that we can quickly see if they are equal,
% or where they differ. It checks the sizes, prints 
% max(max(abs(matrix1 - matrix2))), and prints a 2D index
% where they differ (if they differ).

result = zeros(1, 5);

if size(matrix1, 1) ~= size(matrix2, 1)
    disp('sizes differ');
    disp(size(matrix1));
    disp(size(matrix2));
    return;
end

if size(matrix1, 2) ~= size(matrix2, 2)
    disp('sizes differ');
    disp(size(matrix1));
    disp(size(matrix2));
    return;
end

if size(matrix1, 3) ~= size(matrix2, 3)
    disp('sizes differ');
    disp(size(matrix1));
    disp(size(matrix2));
    return;
end

max_diff = max(max(abs(matrix1 - matrix2)));
result(1) = max_diff;


if (max_diff ~= 0)
    diff_elements = sum(sum(matrix1 ~= matrix2));
    total_elements = prod(size(matrix1));
    disp(sprintf('max_diff = %f', max_diff));
    disp(sprintf('different elements: %d out of %d', diff_elements, total_elements));
     [vi, vj] = find(matrix1 ~= matrix2);
    row = vi(1);
    col = vj(1);
    result(2) = row;
    result(3) = col;
    result(4) = matrix1(row, col);
    result(5) = matrix2(row, col);
    disp(sprintf('index where unequal: %d %d', row, col));
    disp(sprintf('matrix1(%d, %d) = %f', row, col, matrix1(row, col)));
    disp(sprintf('matrix2(%d, %d) = %f', row, col, matrix2(row, col)));
else
    disp('matrices are equal');
end
